local a,t=...
local e,f={},{}
local PG=CreateFrame('frame',a)
t.gear,t.gearinsets,t.portgearequipped={},{},{}

function f.CacheSets(gearsetonly)
	if not CanUseEquipmentSets() then return end
	t.gearinsets={}
	for i=1,GetNumEquipmentSets() do
		local name,_,_,equipped=GetEquipmentSetInfo(i)
		if not name then break end
		if equipped then
			t.gearset=i
			t.portgearequipped={}
		end
		if not gearsetonly then
			local set=GetEquipmentSetItemIDs(name)
			for _,v in next,set do
				if t.gearinsets[v] then
					tinsert(t.gearinsets[v],i,true)
				else
					t.gearinsets[v]={[i]=true}
				end
			end
		end
	end
end -- cache all set gear and current set

function f.EquipOriginalItem()
	if t.portgearused and not t.combat and not InCombatLockdown() then
		EquipItemByName(t.gear[t.portgearused],t.portgearused)
		t.portgearequipped[t.portgearused]=nil
		t.portgearused=false
	end
end -- equip original item after using a teleport item

function f.SetGear(silent)
	for i=1,19 do t.gear[i]=GetInventoryItemLink('player',i) end
	t.portgearequipped={}
	if silent~='silent' then print("|cffff0000"..a..":|r saved current gear") end
end -- cache all current gear, assuming all normally worn even if port gear

function e.PLAYER_LOGIN()
	f.CacheSets()
	f.SetGear('silent')
	SLASH_PORTGEAR1='/pg'
	SLASH_PORTGEAR2='/portgear'
	SlashCmdList.PORTGEAR=f.SetGear -- manual refresh of all current gear
	PG:UnregisterEvent('PLAYER_LOGIN')
end

function e.EQUIPMENT_SETS_CHANGED() f.CacheSets() end

function e.PLAYER_EQUIPMENT_CHANGED(slot)
	local id=GetInventoryItemID('player',slot)
	local link=GetInventoryItemLink('player',slot)
	if t.portgear[id] and (not t.gearinsets[id] or not t.gearinsets[id][t.gearset]) and t.gear[slot]~=link then
		t.portgearequipped[slot]=true
	else
		t.gear[slot]=link
		if t.portgearequipped[slot] then t.portgearequipped[slot]=nil end
	end
	f.CacheSets(true)
end -- cache non-port gear, port gear not normally worn, and current set after item change

function e.PLAYER_REGEN_DISABLED() t.combat=true end
function e.PLAYER_REGEN_ENABLED() t.combat=false f.EquipOriginalItem() end -- track combat and swap if needed

function e.UNIT_SPELLCAST_SUCCEEDED(unit)
	if unit=='player' then
		for k,v in next,t.portgearequipped do
			if v then
				local cd=GetInventoryItemCooldown('player',k)
				if cd and cd~=0 then
					t.portgearused=k
					f.EquipOriginalItem()
				end
			end
		end
	end
end -- watch spell casting for port gear usage

PG:RegisterEvent('PLAYER_LOGIN')
PG:RegisterEvent('EQUIPMENT_SETS_CHANGED')
PG:RegisterEvent('PLAYER_EQUIPMENT_CHANGED')
PG:RegisterEvent('PLAYER_REGEN_DISABLED')
PG:RegisterEvent('PLAYER_REGEN_ENABLED')
PG:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED')
PG:SetScript('OnEvent',function(_,event,...)e[event](...)end)